-- DATE OF TESTING 8/10/2012 on actual ATE Tool db

SELECT * FROM `WorkPackage` WHERE `Name` IS NULL AND `SAP_ID` IS NULL;
(559 records)

SELECT * FROM `WorkPackage` WHERE `Name` IS NULL OR `SAP_ID` IS NULL;
(559 records)

Conclusion:
If Workpackage name is NULL then SAP_ID is NULL.


All tasks that have Dummy workpackage as parent:

SELECT * FROM `Task`,`WorkPackage` WHERE `Task`.`WorkPackage_ID`=`WorkPackage`.`WorkPackage_ID`
AND `WorkPackage`.`SAP_ID` IS NULL;

(512 records)

Dummy Parent Work Packages: 
SELECT * FROM `WorkPackage`,`WorkPackage` as `upperlevelwp`
WHERE `WorkPackage`.`Name` IS NULL AND `WorkPackage`.`SAP_ID` IS NULL
 AND `upperlevelwp`.`WorkPackage_ID`=`WorkPackage`.`Parent_ID`
 AND `upperlevelwp`.`SAP_ID` IS NULL;
(44 records)

Conclusion:
There are at least two levels or dummy workpackages => USE PROCEDURE
-- -----------------------------------------------------------------------------


--
-- Dummy workpackage clean up
--
--- PREPARATIONS
DROP TABLE IF EXISTS `DummyWorkPackageTaskRemap`;
CREATE TABLE `DummyWorkPackageTaskRemap` (
  `Task_ID` int(11) NOT NULL,
  `WorkPackageDummy` int(11) NOT NULL,
  `WorkPackageNew` int(11) NOT NULL, 
  PRIMARY KEY `Task_ID` (`Task_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
DROP PROCEDURE IF EXISTS `RemapDummyWorkPackages`;
DELIMITER ;;
CREATE PROCEDURE `RemapDummyWorkPackages` ()
BEGIN
  DECLARE wid INT;
  DECLARE tid INT;
  DECLARE p_wid INT;
  DECLARE new_wid INT;
  DECLARE wp_sap_id VARCHAR(100);
  DECLARE done INT DEFAULT 0;
  DECLARE dummy_wp_cursor CURSOR FOR SELECT `Task`.`Task_ID`, `WorkPackage`.`WorkPackage_ID` FROM `Task`,`WorkPackage` WHERE `Task`.`WorkPackage_ID`=`WorkPackage`.`WorkPackage_ID`
AND `WorkPackage`.`SAP_ID` IS NULL;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  
  OPEN dummy_wp_cursor;
  
  read_loop: LOOP
    FETCH dummy_wp_cursor INTO tid, wid;
    IF done = 1 THEN
      LEAVE read_loop;
    END IF;
    -- find for task first non-NULL workpackage in the WBS tree
    SET new_wid = wid;
    SET wp_sap_id = NULL; 
    REPEAT
      SELECT `Parent_ID` INTO p_wid FROM `WorkPackage` WHERE `WorkPackage_ID`=new_wid;
      SELECT `SAP_ID` INTO wp_sap_id FROM `WorkPackage` WHERE `WorkPackage_ID`=p_wid;
      SET new_wid = p_wid;
    UNTIL (wp_sap_id IS NOT NULL)
    END REPEAT; 
    INSERT INTO `DummyWorkPackageTaskRemap` (`Task_ID`, `WorkPackageDummy`, `WorkPackageNew`) VALUES (tid, wid, new_wid);
    -- SELECT statements can lead to NOT FOUND HANDLER call thus setting done to 1 and prematurely ending the loop
    SET done = 0;
  END LOOP read_loop;  

  CLOSE dummy_wp_cursor;

END ;;
DELIMITER ;

--- FIX
CALL `RemapDummyWorkPackages`;
UPDATE `Task`,`DummyWorkPackageTaskRemap` SET `Task`.`WorkPackage_ID`=`DummyWorkPackageTaskRemap`.`WorkPackageNew` 
WHERE `Task`.`WorkPackage_ID`=`DummyWorkPackageTaskRemap`.`WorkPackageDummy`;
--- CLEAN UP
DELETE FROM `WorkPackage` WHERE `SAP_ID` IS NULL;
DROP TABLE IF EXISTS `DummyWorkPackageTaskRemap`;
DROP PROCEDURE IF EXISTS `RemapDummyWorkPackages`;

 
------- ALTERNATIVE WITH LOGGING
DROP TABLE IF EXISTS `DummyWorkPackageTaskRemap`;
CREATE TABLE `DummyWorkPackageTaskRemap` (
  `Task_ID` int(11) NOT NULL,
  `WorkPackageDummy` int(11) NOT NULL,
  `WorkPackageNew` int(11) NOT NULL, 
  PRIMARY KEY `Task_ID` (`Task_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

DROP TABLE IF EXISTS `DummyWorkPackageTaskRemapLog`;
CREATE TABLE `DummyWorkPackageTaskRemapLog` (
  `Task_ID` int(11) NOT NULL,
  `WorkPackage` int(11) NOT NULL,
  `WorkPackageParent` int(11),
  `SAP_ID` VARCHAR(100)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

DROP PROCEDURE IF EXISTS `RemapDummyWorkPackages`;
DELIMITER ;;
CREATE PROCEDURE `RemapDummyWorkPackages` ()
BEGIN
  DECLARE wid INT;
  DECLARE tid INT;
  DECLARE p_wid INT;
  DECLARE new_wid INT;
  DECLARE wp_sap_id VARCHAR(100);
  DECLARE done INT DEFAULT 0;
  DECLARE dummy_wp_cursor CURSOR FOR SELECT `Task`.`Task_ID`, `WorkPackage`.`WorkPackage_ID` FROM `Task`,`WorkPackage` WHERE `Task`.`WorkPackage_ID`=`WorkPackage`.`WorkPackage_ID`
AND `WorkPackage`.`SAP_ID` IS NULL;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  
  OPEN dummy_wp_cursor;
  
  read_loop: LOOP
    FETCH dummy_wp_cursor INTO tid, wid;
    IF done = 1 THEN
      LEAVE read_loop;
    END IF;
    -- find for task first non-NULL workpackage in the WBS tree
    SET new_wid = wid;
    SET wp_sap_id = NULL; 
    REPEAT
      SELECT `Parent_ID` INTO p_wid FROM `WorkPackage` WHERE `WorkPackage_ID`=new_wid;
      SELECT `SAP_ID` INTO wp_sap_id FROM `WorkPackage` WHERE `WorkPackage_ID`=p_wid;
      INSERT INTO `DummyWorkPackageTaskRemapLog` (`Task_ID`, `WorkPackage`, `WorkPackageParent`, `SAP_ID`) VALUES (tid, new_wid, p_wid, wp_sap_id);

      SET new_wid = p_wid;
    UNTIL (wp_sap_id IS NOT NULL)
    END REPEAT; 
    IF new_wid IS NULL THEN
       SET new_wid = 0; 
    END IF;
    INSERT INTO `DummyWorkPackageTaskRemap` (`Task_ID`, `WorkPackageDummy`, `WorkPackageNew`) VALUES (tid, wid, new_wid);
    -- SELECT statements can lead to NOT FOUND HANDLER call thus setting done to 1 and prematurely ending the loop
    SET done = 0;
  END LOOP read_loop;  

  CLOSE dummy_wp_cursor;

END ;;
DELIMITER ;