-- ATE Tool database upgrade script 
-- From version     : 1.14.0
-- To version       : 1.15.0
-- Target DB engine : MySQL 5.5.x

-- Sign of leadership status of organization unit
ALTER TABLE `OrganizationUnit` ADD `ActingLeader` TINYINT(1) NOT NULL DEFAULT '0' AFTER `Leader`;

-- Deletes all admin roles
DELETE FROM `User` WHERE `User`.`Role` LIKE 'ADMIN';

-- Inserts admin roles only for admins
 INSERT INTO `User` (`EID`, `Role`) VALUES 
 ('E589510', 'ADMIN'),
 ('E592399', 'ADMIN'),
 ('E804970', 'ADMIN'), 
 ('E854927', 'ADMIN');
 
 -- Organization Unit status
ALTER TABLE `OrganizationUnit` ADD `Status` TINYINT(1) NOT NULL DEFAULT '1';

-- Frozen labor rate for technical group
ALTER TABLE `ProjectCharterBudget` ADD `Rate` DECIMAL(20, 2) DEFAULT NULL AFTER `Subcontractor`;

-- Filling frozen labor rate
DROP VIEW IF EXISTS `temp_charter_budget_map`;
CREATE VIEW `temp_charter_budget_map` AS
SELECT DISTINCT `ProjectCharterBudget`.`ProjectCharterBudget_ID`, `ProjectCharter`.`Year`, `ProjectCharterBudget`.`TechnicalGroup`, `OrganizationUnit`.`CostCenter_ID`
FROM `ProjectCharterBudget`
JOIN `ProjectCharter` ON `ProjectCharterBudget`.`ProjectCharter_ID` = `ProjectCharter`.`ProjectCharter_ID`
JOIN `OrganizationUnit` ON  `ProjectCharterBudget`.`TechnicalGroup` = `OrganizationUnit`.`OrganizationUnit_ID`;

UPDATE `ProjectCharterBudget`
SET `ProjectCharterBudget`.`Rate` = (
    SELECT DISTINCT `Rate`.`Jan`
    FROM `Rate`, `temp_charter_budget_map`
    WHERE `temp_charter_budget_map`.`Year` = `Rate`.`Year`
          AND `temp_charter_budget_map`.`CostCenter_ID` = `Rate`.`CostCenter_ID`
          AND `temp_charter_budget_map`.`TechnicalGroup` = `ProjectCharterBudget`.`TechnicalGroup`
          AND `temp_charter_budget_map`.`ProjectCharterBudget_ID` = `ProjectCharterBudget`.`ProjectCharterBudget_ID`

);

DROP VIEW IF EXISTS `temp_charter_budget_map`;

-- Column CostCenter_ID is no more needed
ALTER TABLE `OrganizationUnit` DROP FOREIGN KEY `organizationunit_ibfk_2`;
ALTER TABLE `OrganizationUnit` DROP COLUMN `CostCenter_ID`;
