-- ATE Tool database upgrade script 
-- From version     : 1.17.0
-- To version       : 1.18.0
-- Target DB engine : MySQL 5.6.x

-- Notification table added
CREATE TABLE IF NOT EXISTS `Notification` (
	`Id` INT(11) NOT NULL AUTO_INCREMENT,
    -- WARNING: got to use TIMESTAMP instead of DATETIME (because of MySQL 5.5)
    -- TIMESTAMP can only handle date until 2038!
	`Created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    `Subject` VARCHAR(100) NOT NULL,
    `Message` TEXT,
    `Type` ENUM('Info', 'Warning', 'Critical') NOT NULL DEFAULT 'Info',
	PRIMARY KEY(`Id`)
) ENGINE = InnoDB CHARSET = utf8 COLLATE utf8_unicode_ci;

-- Notification Recipient added
CREATE TABLE IF NOT EXISTS `NotificationRecipient` (
	`Notification_ID` INT(11) NOT NULL,
    `Recipient` VARCHAR(7) NOT NULL,
    `Seen` DATETIME,
    PRIMARY KEY(`Notification_ID`, `Recipient`),
    FOREIGN KEY(`Notification_ID`) REFERENCES `Notification` (`Id`),
    FOREIGN KEY (`Recipient`) REFERENCES `Person` (`EID`)
) ENGINE = InnoDB CHARSET = utf8 COLLATE utf8_unicode_ci;

ALTER TABLE `NotificationRecipient` ADD CONSTRAINT FOREIGN KEY (`Notification_ID`) REFERENCES `Notification` (`Id`);
ALTER TABLE `NotificationRecipient` ADD CONSTRAINT FOREIGN KEY (`Recipient`) REFERENCES `Person` (`EID`);

-- Refactor adminList and testerList
UPDATE `GlobalSetting` SET `Value` = 'E589510,E854927,H144983' WHERE `Key` = 'mail.adminList';
UPDATE `GlobalSetting` SET `Value` = 'E589510,E854927,H144983' WHERE `Key` = 'mail.testerList';