# FileName: charters-auto-approval.ps1
#=============================================================================
# Script Name: [ATE PLANNING TOOL Project Charters Auto Approval]
# Created: [12/8/2013]
# Version: [1.0]
# Author: [Martin Kotlar]
# Email: [martin.kotlar@honeywell.com]
# Company: [Honeywell]  
# Arguments: None
# =============================================================================
# Purpose: This script is to be setup in Windows Server / Windows 7 
# Task Scheduler should be setup to run this task hourly to  
# trigger auto approval of project charters pending approvals after final approval date.
# =============================================================================

$log="C:\inetpub\wwwroot\hon-planning-tool\log\auto-approve-charters.log"
#logrotate first if log is greater than 500kB
if (Test-Path $log) { 
    if ((Get-Item $log).length -gt 500kb) {
        $old_log= $log -replace ".log$", ("-" + (Get-Date -UFormat "%Y%m%d-%H%M%S") + ".log")
        Move-Item $log $old_log
    }
}

# token HTTP parameter is setup in the ATE Planning Tool database 
# in table GlobalSettings in a Value column where Key="charters.credentials.schedulerToken" 
$url="http://ate-apps.honeywell.com/hon-planning-tool/?presenter=ProjectCharterAutoApproval&token=dfcdd84c9d909800b63ff1c2983e7c54&action=run"
# run only once and max for 5 minutes
$my_wget_cmd="c:\Program Files (x86)\UnixUtils\bin\wget.exe"
$my_wget_params=@("-t","1","-T","300","-O","-","$url") 
$my_unix_date_format="%Y/%m/%d %H:%M:%S"

$my_start_date=(Get-Date -UFormat $my_unix_date_format)
Add-Content -Path $log -Value "--- START OF PROJECT CHARTER AUTO APPROVAL: $my_start_date"
& $my_wget_cmd $my_wget_params | Add-Content -Path $log     
$my_end_date=(Get-Date -UFormat $my_unix_date_format)
Add-Content -Path $log -Value "--- END OF PROJECT CHARTER AUTO APPROVAL: $my_end_date"

exit