<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2015 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package presenters
 */

/**
 * Organization unit person selector
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
class OrganizationUnitPersonSelectorContainer extends OrganizationUnitSelectorContainer
{
	/**
	 * @param int $width=300 Width of container fields. Min value = 60
	 * @param boolean $showHierarchy=FALSE Cut short each field in hierarchy
	 */
	public function __construct($width = 300, $showHierarchy = FALSE)
    {
		parent::__construct($width, $showHierarchy);
	}
	
	/**
	 * Gets all org unit by type even inactive unit.
	 * 
	 * @param string $type Type of organization unit in range of OrganizationUnit::ORG_UNIT_TYPE_*.
	 * @return array Array of OrganizationUnit where Organization unit ID is key.
	 */
	protected function getAllOrgUnitByType($type)
	{
		return $this->context->organizationUnitRepository->findAllOrgUnitByType($type, TRUE);
	}
	
	/**
	 * Gets all children by type  even inactive unit.
	 * 
	 * @param int $orgUnitID organization unit ID.
	 * @param string $type Type of organization unit in range of OrganizationUnit::ORG_UNIT_TYPE_*.
	 * @return	array of OrganizationUnit where id is key or empty array.
	 */
	protected function getAllChildrenByType($orgUnitID, $type)
	{
		return $this->context->organizationUnitRepository->findAllChildrenByType($orgUnitID, $type, TRUE);
	}
}
