<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2014 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * ECLicenceName definition.
 *
 * @author Vojtech Obrusnik <vojtech.obrusnik@honeywell.com>
 */
class ECLicenceName extends Object
{
	/** @var int ECLicenceName id */
	private $ECLicenceNameID;
	/** @var string ECLicenceName */
	private $name;
	
	/**
     * Sets id.
     * @param int $id Must be positive integer.
	 * @throws InvalidArgumentException
     */
	public function setECLicenceNameID($id)
	{
		if ($id > 0)
			$this->ECLicenceNameID = $id;
		else
			throw new InvalidArgumentException('ECLicenceName ID must be integer greater than 0. Wrong param: ' . $id);
	}
	
	/**
     * Gets id
     * @return int
     */
	public function getECLicenceNameID()
	{
		return $this->ECLicenceNameID;
	}
	
	/**
     * Sets name
     * @param string $name
     */
	public function setName($name)
	{
		$this->name = $name;
	}
	
	/**
     * Gets name
     * @return string
     */
	public function getName()
	{
		return $this->name;
	}
}
