<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2011 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing responsibilities.
 *
 * @author Jiri Zajic <jiri.zajic@honeywell.com>
 */
interface IResponsibilityMapper
{
	/**
	 * Saves responsibility.
	 * 
     * @param Responsibility $responsibility responsibility
	 */
	public function save(Responsibility $responsibility);
    
	/**
	 * Updates responsibility.
	 * 
	 * @param Responsibility $responsibility responsibility
	 */
	public function update(Responsibility $responsibility);
    
	/**
	 * Returns responsibility by its id.
	 * 
	 * @param int $id Responsibility ID.
	 * @return Responsibility
	 */
	public function findResponsibility($id);

	/**
	 * Returns all responsibilities as an array sorted by name.
	 * 
	 * @return array of Responsibility
	 */
	public function findAllResponsibilities();

}
