<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2015 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing statistics
 *
 * @author Vojtech Obrusnik <vojtech.obrusnik@honeywell.com>
 */
interface IStatisticsMapper
{
    /**
	 * Saves record
	 *
	 * @param Statistics $stat
	 * @return boolean True on success, false otherwise
	 */
	public function save(Statistics $stat);

	/**
	 * Updates record
	 *
	 * @param Statistics $stat
	 * @return boolean True on success, false otherwise
	 */
	public function update(Statistics $stat);

	/**
	 * Deletes record
	 * 
	 * @throws InvalidStateException
	 */
	public function delete();
	
	/**
	 * Finds record
	 * 
	 * @throws InvalidStateException
	 */
	public function find();
	
	/**
	 * Finds all records
	 *
	 * @throws InvalidStateException
	 */
	public function findAll();

	/**
	 * Finds record by content
	 *
	 * @param int $action
	 * @param string $detail
	 * @param string $user
	 * @return Statistict Or null if not found
	 */
	public function findByContent($action, $detail, $user);
}
