<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2011, 2012 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing user roles.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
interface IUserRoleMapper
{   
    /**
	 * Finds roles by person id.
	 * 
	 * @param string $id person ID.
	 * @return	array of UserRole.
	 */    
    public function findUserRoles($id);
    
     /**
     * Saves UserRole.
     * 
     * @param UserRole $userRole
     * @return boolean Returns true if create successfull, otherwiste returns false.
     */
    public function save(UserRole $userRole);
    
    /**
     * Deletes UserRole.
     * 
     * @param string $role
     * @param string $person_id
     * @return boolean Return true if delete successfull, otherwise returns false.
     */
    public function delete($person_id, $role); 
}
