<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2016 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Newly found persons from iASAP import.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
class PersonFound extends Object
{
	/** @var string */
	private $id;	
	/** @var string */
	private $eid;
	/** @var string */
	private $name;
	/** @var string */
	private $surname;
	/** @var string */
	private $workCenterID;
	/** @var string */
	private $supervisorEID;
	/** @var string */
	private $supervisorName;
	/** @var string */
	private $supervisorSurname;
	/** @var int */
	private $organizationUnitID;
	/** @var int */
	private $blacklisted;
	

	public function __construct()
	{
	}

    /**
     * Sets customer ID.
     * 
     * @param $id string
     */
	public function setID($id)
	{
		if ($id > 0)
			$this->id = $id;
		else
			throw new InvalidArgumentException('PersonFound ID must be integer greater than 0. Wrong param: '.$id);
	}

    /**
     * Gets customer ID.
     * 
     * @return string
     */
	public function getID()
	{
		return $this->id;
	}	
	
    /**
     * Sets person eid.
     * 
     * @param string $eid
     */
	public function setEID($eid)
	{
		$this->eid = $eid;
	}

    /**
     * Gets person eid.
     * 
     * @return string
     */
	public function getEID()
	{
		return $this->eid;
	}
	
    /**
     * Sets person name.
     * 
     * @param string $name
     */
	public function setName($name)
	{
		$this->name = $name;
	}

    /**
     * Gets person name.
     * 
     * @return string
     */
	public function getName()
	{
		return $this->name;
	}
	
    /**
     * Sets person surname.
     * 
     * @param string $surname
     */
	public function setSurname($surname)
	{
		$this->surname = $surname;
	}

    /**
     * Gets person surname.
     * 
     * @return string
     */
	public function getSurname()
	{
		return $this->surname;
	}
	
    /**
     * Sets person WC ID.
     * 
     * @param string $wcID
     */
	public function setWorkCenterID($wcID)
	{
		$this->workCenterID = $wcID;
	}

    /**
     * Gets person WC ID.
     * 
     * @return string
     */
	public function getWorkCenterID()
	{
		return $this->workCenterID;
	}
	
    /**
     * Sets supervisor EID.
     * 
     * @param string $supervisorEID
     */
	public function setSupervisorEID($supervisorEID)
	{
		$this->supervisorEID = $supervisorEID;
	}

    /**
     * Gets supervisor EID.
     * 
     * @return string
     */
	public function getSupervisorEID()
	{
		return $this->supervisorEID;
	}
	
    /**
     * Sets upervisor name.
     * 
     * @param string $supervisorName
     */
	public function setSupervisorName($supervisorName)
	{
		$this->supervisorName = $supervisorName;
	}

    /**
     * Gets supervisor name.
     * 
     * @return string
     */
	public function getSupervisorName()
	{
		return $this->supervisorName;
	}
	
    /**
     * Sets upervisor surname.
     * 
     * @param string $supervisorSurname
     */
	public function setSupervisorSurname($supervisorSurname)
	{
		$this->supervisorSurname = $supervisorSurname;
	}

    /**
     * Gets supervisor name.
     * 
     * @return string
     */
	public function getSupervisorSurname()
	{
		return $this->supervisorSurname;
	}
	
   /**
     * Sets ID of organization unit.
     * @param int $id Must be positive integer.
     */
	public function setOrganizationUnitID($id)
	{
		if ($id > 0 || is_null($id))
			$this->organizationUnitID = $id;
		else
			throw new InvalidArgumentException('Organization unit ID must be integer greater than 0. Wrong param: '.$id);
	}
	
    /**
     * Gets ID of organization unit.
     * @return int
     */
	public function getOrganizationUnitID()
	{
		return $this->organizationUnitID;
	}
	
	/**
	 * Sets blacklisted.
     * @param boolean $blacklisted
     */
    public function setBlacklisted($blacklisted)
    {
        $this->blacklisted = ($blacklisted) ? TRUE : FALSE;
    }

    /**
	 * Gets blacklisted.
     * @return boolean
     */
    public function getBlacklisted()
    {
        return $this->blacklisted;
    }
}
