<?php

/**
 * This file is part of the ATE Tool - STRAP addon
 *
 * Copyright (c) 2009, 2013 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * STRAP NeedToPursue represents one possible part from STRAP Item.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
class NeedToPursue extends Object
{
	/** @var int */
	private $id;

	/** @var string */
	private $name;
	
	/** @var string */
	private $potentialCustomer;
	
	public function __construct()
	{
	}

    /**
     * Sets item ID.
     * 
     * @param int $id
     */
	public function setID($id)
	{
		if ($id > 0)
			$this->id = $id;
		else
			throw new InvalidArgumentException('STRAP NeedToPursue ID must be integer greater than 0. Wrong param: '.$id);
	}

    /**
     * Gets item ID.
     * 
     * @return int
     */
	public function getID()
	{
		return $this->id;
	}	
	
    /** 
     * Sets name. 
     *  
     * @param string $name  
     */ 
    public function setName($name) 
    { 
            $this->name = $name; 
    } 

    /** 
     * Gets name. 
     *  
     * @return string 
     */ 
    public function getName() 
    { 
            return $this->name; 
    } 
	
    /** 
     * Sets potentialCustomer. 
     *  
     * @param string $potentialCustomer  
     */ 
    public function setPotentialCustomer($potentialCustomer) 
    { 
		$this->potentialCustomer = $potentialCustomer; 
    } 

    /** 
     * Gets potentialCustomer. 
     *  
     * @return string 
     */ 
    public function getPotentialCustomer() 
    { 
		return $this->potentialCustomer; 
    } 
}
