<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2011 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Reimplementation of Identity class to assure that user roles
 * are always actual according to the database setting
 * and not from session saved roles.
 *
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
class LDAPValidIdentity extends Identity
{
    /** @const USER_TYPE */
    const USER_TYPE = 'LDAP_valid';
    public $userType = self::USER_TYPE;

    /**
	 * Returns a list of roles that the user is a member of.
	 * @return array
	 * @todo Rewrite using UserRolesRepository
	 */
	public function getRoles()
	{
        $db_rolenames = dibi::select('Role')->from('User')->where('[EID] LIKE %s', $this->getId())->execute();
        $roles = array();
        if (count($db_rolenames) > 0)
		{
            foreach ($db_rolenames as $db_rolename)
				$roles[] = $db_rolename->Role;
		}
		return $roles;
	}	
}


