<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2013 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Subcontractor definition.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 *
 */
class Subcontractor extends Object
{
    /** @var int ID */
    private $id;
    /** @var string Name of subcontractor */
    private $name;
    /** @var string Short of subcontractor*/
    private $short;
	/** @var bool True when active, false when inactive. */
	private $status;
    
   /**
     * Sets ID of subcontractor.
     * @param int $id Must be positive integer.
     */
	public function setID($id)
	{
		if ($id > 0)
			$this->id = $id;
		else
			throw new InvalidArgumentException('Subcontractor ID must be integer greater than 0. Wrong param: '.$id);
	}
	
    /**
     * Gets ID of subcontractor.
     * @return int
     */
	public function getID()
	{
		return $this->id;
	}
        
	/**
     * Sets name of subcontractor.
     * @param string $name
     */
	public function setName($name)
	{
        $this->name = $name;
	}

    /**
     * Gets name of subcontractor.
     * @return string
     */
	public function getName()
	{
		return $this->name;
	}
    
   /**
     * Sets short of subcontractor.
     * @param string $short.
     */
	public function setShort($short)
	{
		$this->short = $short;
	}
	
    /**
     * Gets short of subcontractor.
     * @return string
     */
	public function getShort()
	{
		return $this->short;
	}

   /**
     * Sets the status of subcontractor.
     * @param bool $status.
     */
	public function setStatus($status)
	{
		$this->status = ($status) ? TRUE : FALSE;
	}
	
    /**
     * Gets the status of subcontractor.
     * @return bool
     */
	public function getStatus()
	{
		return $this->status;
	}
}